
#include "lg/interface.h"
#include "lg/scrservices.h"
#include "ScriptLib.h"
#include "GenericTrigger.h"


void cScrTrigger::InitTrigVars()
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (pPropSrv->Possessed(m_iObjId, "TrapFlags"))
	{
		cMultiParm mpTrapFlags = 0;
		pPropSrv->Get(mpTrapFlags, m_iObjId, "TrapFlags", NULL);
		m_iFlags = static_cast<int>(mpTrapFlags);
	}
}

bool cScrTrigger::IsLocked(sScrMsg* pMsg)
{
	SService<ILockSrv> pLock(g_pScriptManager);
	return pLock->IsLocked(m_iObjId);
}

void cScrTrigger::SetLock(bool bLock)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	cMultiParm mpLock = static_cast<int>(bLock);
	pPropSrv->Set(m_iObjId, "Locked", mpLock);
}

long cScrTrigger::DoTurnOn(const cMultiParm& mpData)
{
	if (m_iFlags & kTrapFlagNoOn)
		return 0;
	if (m_iFlags & kTrapFlagOnce)
		SetLock(true);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	return pLS->BroadcastOnAllLinks(m_iObjId, (m_iFlags & kTrapFlagInvert) ? "TurnOff" : "TurnOn", 
			pLTS->LinkKindNamed("ControlDevice"), g_mpUndef);
}

long cScrTrigger::DoTurnOff(const cMultiParm& mpData)
{
	if (m_iFlags & kTrapFlagNoOff)
		return 0;
	if (m_iFlags & kTrapFlagOnce)
		SetLock(true);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	return pLS->BroadcastOnAllLinks(m_iObjId, (m_iFlags & kTrapFlagInvert) ? "TurnOn" : "TurnOff", 
			    pLTS->LinkKindNamed("ControlDevice"), g_mpUndef);
}
