
#include "lg/interface.h"
#include "lg/scrservices.h"
#include "ScriptLib.h"
#include "GenericControl.h"


long cScrControl::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	char* pszControl = GetObjectParamString(m_iObjId, "on");
	if (!pszControl)
		pszControl = GetObjectParams(m_iObjId);
	long iRet = 1;
	if (pszControl)
	{
		iRet = OnControlString(pszControl, pMsg, pReply);
		g_pMalloc->Free(pszControl);
	}
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrControl::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	char* pszControl = GetObjectParamString(m_iObjId, "off");
	long iRet = 1;
	if (pszControl)
	{
		iRet = OnControlString(pszControl, pMsg, pReply);
		g_pMalloc->Free(pszControl);
	}
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrControl::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pMsg->data.type != kMT_String || pMsg->data.psz == NULL)
		return 1;
	return OnControlString(pMsg->data.psz, pMsg, pReply);
}


